unit Unit1;

interface

uses
  Windows, Messages,SysUtils,
  Variants, Classes, Graphics,
  Controls, Forms, Dialogs,
  ComCtrls, Menus, ExtCtrls,
  StdCtrls, Ucomunes, math;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    Image1: TImage;
    Button4: TButton;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    Label2: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    coord: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Image1MouseEnter(Sender: TObject);
    procedure Image1MouseLeave(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    fig     : CFigura;
    papel   : Tcanvas;
    NPX,NPY,
    XX,YY,
    Ang     : integer;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// create de la Forma
procedure TForm1.FormCreate(Sender: TObject);
begin
  papel := Image1.Canvas;

  NPX   := Image1.Width;
  NPY   := Image1.Height;

  XX  := 50;
  YY  := 50;
  Ang := 0;

  coord.Hide;
end;

// Metodo abrir Arcbhivo de figura
procedure TForm1.Button1Click(Sender: TObject);
var
  k  : word;
  id : TextFile;
  nn : string;
begin
  // asignando el nombre en disco al manejado
  AssignFile(id,'./bib1/fig1.sut');
  // abrir para lectura
  reset(id);

  // manipularlo
  readln(id,nn);
  Memo1.Lines.Add(nn);

  // leer puntos
  Memo1.Lines.Add('');
  readln(id,fig.np);
  Memo1.Lines.Add('NP= '+IntToStr(fig.np));

  Setlength(fig.Apun,fig.np,2);
  for k := 0 to fig.np - 1 do begin
    readln(id,fig.Apun[k][0], fig.Apun[k][1]);
    Memo1.Lines.Add(
         FloatToStr(fig.Apun[k][0])+ ' '+
         FloatToStr(fig.Apun[k][1]));
  end;

  // leer trazos
  Memo1.Lines.Add('');
  readln(id,fig.nt);
  Memo1.Lines.Add('NT= '+IntToStr(fig.nt));

  Setlength(fig.Atra,fig.nt,2);
  for k := 0 to fig.nt - 1 do begin
    readln(id,fig.Atra[k][0], fig.Atra[k][1]);
    Memo1.Lines.Add(
         IntToStr(fig.Atra[k][0])+ ' '+
         IntToStr(fig.Atra[k][1]));
  end;

  // leer un renglon y omitir su contenido
  readln(id);

  // PC escala
  Memo1.Lines.Add('');
    readln(id,fig.PCEx , fig.PCEy);
    Memo1.Lines.Add(
         FloatToStr(fig.PCEx)+ ' '+
         FloatToStr(fig.PCEy));

  // PC rotacion
  Memo1.Lines.Add('');
    readln(id,fig.PCRx, fig.PCRy);
    Memo1.Lines.Add(
         FloatToStr(fig.PCRx)+ ' '+
         FloatToStr(fig.PCRy));

  // Escribir el nombre de la Figura
  StatusBar1.Panels[0].Text := nn;

  // Escribir la posicion Figura
  StatusBar1.Panels[1].Text := IntToStr(XX);
  StatusBar1.Panels[2].Text := IntTostr(YY);

  // Escribir el angulo de rotacion Figura
  StatusBar1.Panels[3].Text := IntToStr(Ang);
  // cerrar archivo
  CloseFile(id);
end;


// ------ del escenario

// refrescar escenario
procedure TForm1.Button4Click(Sender: TObject);
var
  p,q,k, ff   : integer;
  XL,YL,
  PEx,PEy,
  PRx,PRy,
  Xe,Ye,
  Xr,Yr,
  Se,Co       : single;
begin
  papel.Rectangle(0,0,NPX,NPY);
  ff := 10;

  // recorer trazos
  for k := 0 to fig.nt - 1 do begin
    p := fig.Atra[k][0];
    q := fig.Atra[k][1];

    PEx := fig.PCEx;
    PEy := fig.PCEy;

    PRx := fig.PCRx;
    PRy := fig.PCRy;

    XL := fig.Apun[p][0];
    YL := fig.Apun[p][1];

    // Punto inicial
    // escalar
    Xe := ff*(XL-PEx)+PEx - PRx;
    Ye := ff*(YL-PEy)+PEy - PRy;

    // Rotacion
    Se := sin(Pi*Ang/180);
    Co := cos(Pi*Ang/180);

    Xr := Xe*Co - Ye*Se + PRx;
    Yr := Xe*Se + Ye*Co + PRy;

    papel.MoveTo(     XX + ceil(Xr),
                 NPY-(YY + ceil(Yr)));

    XL := fig.Apun[q][0];
    YL := fig.Apun[q][1];

    // Punto final
    // escalar
    Xe := ff*(XL-PEx)+PEx - PRx;
    Ye := ff*(YL-PEy)+PEy - PRy;

    Xr := Xe*Co - Ye*Se + PRx;
    Yr := Xe*Se + Ye*Co + PRy;

    papel.LineTo(     XX + ceil(Xr),
                 NPY-(YY + ceil(Yr)));

  end;
end;


// Metodos de la Interface de pintar

// muestra el letrero de coordenada
procedure TForm1.Image1MouseEnter(Sender: TObject);
begin
  coord.Show;
end;

// esconde el letrero de coordenada
procedure TForm1.Image1MouseLeave(Sender: TObject);
begin
  coord.Hide;
end;

// actualizamos el letrero con la coordenada actual
procedure TForm1.Image1MouseMove(Sender: TObject;
  Shift : TShiftState;
  X, Y  : Integer);
begin
  coord.Caption := '('+IntToStr(X)+','
                      +IntToStr(NPY-Y)+')';

  coord.top  := Image1.Top  + Y -10;
  coord.left := Image1.Left + X +10;
end;

// se oprime un boton del mouse
procedure TForm1.Image1MouseDown(Sender: TObject;
  Button : TMouseButton;
  Shift  : TShiftState;
  X, Y   : Integer);
begin
  if RadioButton1.Checked then begin
    // pintar la figura en esa coordenada
    XX := X;
    YY := NPY-Y;
    Button4.Click;

    // actualiza posicin de la figuar en el StatusBar1
    StatusBar1.Panels[1].Text := IntToStr(XX);
    StatusBar1.Panels[2].Text := IntTostr(YY);
  end;

  if RadioButton2.Checked then begin
    // Rota la figura en esa coordenada y la pinta
    Ang := Ang + StrToInt(Edit1.Text);
    if (Ang>360) then Ang := Ang - 360; 
    
    StatusBar1.Panels[3].Text := IntTostr(Ang);
    Button4.Click;
  end;

end;


end.
